/***************************************************************************
 *            functions.h
 *
 *  Mon May 29 21:32:09 2006
 *  Copyright  2006  User
 *  Email
 ****************************************************************************/

#ifndef _FUNCTIONS_H
#define _FUNCTIONS_H

#ifdef __cplusplus
extern "C"
{
#endif

	#include <gtk/gtk.h>
	#include <glade/glade.h>
	#include <glib/gprintf.h>
	#include <python2.4/Python.h>


#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif



	
	void
	write_list_into_tree(GList* list, GtkTreeView* treeview, gchar* title);
	
	void 
	append_textview_log(const gchar *message);
	
	void
	write_into_textbuffer(GtkTextView* textview, const gchar* text);
	
	void
	append_to_textbuffer(GtkTextView* textview, const gchar* text);
	
	void
	read_logfile_into_textview(const gchar* logfilename);
	
	void
	show_error_dialog (gchar * message);
	
	GList*
	Py_List_As_GList(PyObject* py_list);

	GList* 
	get_searchfields();
	
	void
	cancel_depsdialog();
	
	gboolean 
	avoid_close_window(GtkWidget *widget,
						GdkEvent* event,
						gpointer data);
	
	
	#define RESET_CURSOR 	cursor = gdk_cursor_new(GDK_LEFT_PTR); \
							gdk_window_set_cursor(GDK_WINDOW(window1->window), cursor); \
							gdk_cursor_unref(cursor);
	
	#define SET_CURSOR	cursor = gdk_cursor_new(GDK_WATCH);	\
						gdk_window_set_cursor(GDK_WINDOW(window1->window), cursor); \
						gdk_cursor_unref(cursor); 


	#define SHOW_WAIT_DIALOG(waittext)	{	\
		GtkLabel* dialogwait_label = (GtkLabel*)glade_xml_get_widget(xml, "dialogwait_label"); \
		GtkWidget* waitdialog = glade_xml_get_widget(xml, "guyum_dialog_wait");	\
		g_signal_connect(G_OBJECT(waitdialog), "destroy", G_CALLBACK(avoid_close_window), NULL); \
		g_signal_connect(G_OBJECT(waitdialog), "delete_event", G_CALLBACK(avoid_close_window), NULL);	\
		gtk_label_set_text(dialogwait_label, waittext);	\
		gtk_widget_show(waitdialog);	\
	}
	
	#define HIDE_WAIT_DIALOG()	{	\
		GtkWidget* waitdialog = glade_xml_get_widget(xml, "guyum_dialog_wait");	\
		gtk_widget_hide(waitdialog);	\
	}
	
	#define SHOW_INSTALLWAIT_DIALOG(waittext)	{	\
		GtkLabel* dialogwait_label = (GtkLabel*)glade_xml_get_widget(xml, "installwait_label"); \
		GtkWidget* waitdialog = glade_xml_get_widget(xml, "guyum_dialog_installwait");	\
		g_signal_connect(G_OBJECT(waitdialog), "destroy", G_CALLBACK(avoid_close_window), NULL); \
		g_signal_connect(G_OBJECT(waitdialog), "delete_event", G_CALLBACK(avoid_close_window), NULL);	\
		gtk_label_set_text(dialogwait_label, waittext);	\
		gtk_widget_show(waitdialog);	\
	}
	
	#define HIDE_INSTALLWAIT_DIALOG()	{	\
		GtkWidget* waitdialog = glade_xml_get_widget(xml, "guyum_dialog_installwait");	\
		gtk_widget_hide(waitdialog);	\
	}	
	
	#define SET_WAIT_LABEL(waittext) {	\
		gdk_threads_enter(); \
		GtkLabel* dialogwait_label = (GtkLabel*)glade_xml_get_widget(xml, "dialogwait_label"); \
		gtk_label_set_text(dialogwait_label, waittext);	\
		gdk_flush(); \
		gdk_threads_leave(); \
	}


	enum {
		TEXT_COLUMN=0, 
		N_COLUMNS
		};	
#ifdef __cplusplus
}
#endif

#endif /* _FUNCTIONS_H */
