/***************************************************************************
 *            guyum_install_component.h
 *
 *  Wed Dec 20 22:44:17 2006
 *  Copyright  2006  User
 *  Email
 ****************************************************************************/

#ifndef _GUYUM_INSTALL_COMPONENT_H
#define _GUYUM_INSTALL_COMPONENT_H

#ifdef __cplusplus
extern "C"
{
#endif

	#include <gtk/gtk.h>
	#include <glib/gprintf.h>	
	#include <include/guyum/gy_package_list.h>
	#include <python2.4/Python.h>
	#include <include/guyum/gy_utils.h>
	#include <include/functions.h>

	
/****************************************************************************
* GOBject-Macros															
****************************************************************************/
	#define GUYUM_TYPE_INSTALL_COMPONENT	(guyum_install_component_get_type())
	
	#define GUYUM_INSTALL_COMPONENT(object)	\
		(G_TYPE_CHECK_INSTANCE_CAST((object), GUYUM_TYPE_INSTALL_COMPONENT, GuyumInstallComponent))
	
	#define GUYUM_INSTALL_COMPONENT_CLASS(klass)	\
		(G_TYPE_CHECK_CLASS_CAST((klass), GUYUM_TYPE_INSTALL_COMPONENT, GuyumInstallComponentClass))
	
	#define GUYUM_IS_INSTALL_COMPONENT(object)	\
		(G_TYPE_CHECK_INSTANCE_TYPE((object), GUYUM_TYPE_INSTALL_COMPONENT))
	
	#define GUYUM_IS_INSTALL_COMPONENT_CLASS(klass)	\
		(G_TYPE_CHECK_CLASS_TYPE ((klass), GUYUM_TYPE_INSTALL_COMPONENT))
	
	#define GUYUM_INSTALL_COMPONENT_GET_CLASS(object)  \
		(G_TYPE_INSTANCE_GET_CLASS ((object), GUYUM_INSTALL_COMPONENT, GuyumInstallComponentClass))

	
	#define GUYUM_INSTALL_COMPONENT_TYPE(object)	\
		(G_TYPE_FROM_INSTANCE(object))
		
	#define GUYUM_INSTALL_COMPONENT_TYPE_NAME(object)	\
		(g_type_name(GUYUM_INSTALL_COMPONENT_TYPE(object)))

/****************************************************************************
* class
****************************************************************************/
	typedef struct _GuyumInstallComponent 		GuyumInstallComponent;
	typedef struct _GuyumInstallComponentClass 	GuyumInstallComponentClass;
	typedef struct _GuyumInstallComponentPrivate GuyumInstallComponentPrivate;
		
	struct _GuyumInstallComponent {
		GObject parent_instance;
		/* private */
		GuyumInstallComponentPrivate *priv;
	};
	
	struct _GuyumInstallComponentClass {
		GObjectClass parent_class;
		void (*destroy) (GuyumInstallComponent *install);
	};
	
	struct _GuyumInstallComponentPrivate {
        gchar* repoid;
		GuyumPackageComposite* deps;		
		
		PyObject *guyuminstall_deps;
		
		PyObject *guyuminstall_module;	/**<  */
		PyObject *guyuminstall_dict;
		PyObject *guyuminstall_class;
		PyObject *guyuminstall_instance;
		
	};

/****************************************************************************
* typical functions															
****************************************************************************/	
	GType guyum_install_component_get_type(void);
	void guyum_install_component_destroy(GuyumInstallComponent* install);

/****************************************************************************
* install component functions															
****************************************************************************/

	void guyum_install_component_install(GuyumInstallComponent* self);

	guint 
	guyum_install_component_preinstall(GuyumInstallComponent* self, 											
											PyObject* py_package,
                                        GuyumPackageComponent* package);
	
	gchar* 
	guyum_install_component_get_totalamount(GuyumInstallComponent* self);
	

#ifdef __cplusplus
}
#endif

#endif /* _GUYUM_INSTALL_COMPONENT_H */
