/***************************************************************************
 *            guyum_main.h
 *
 *  Sat May 20 20:00:44 2006
 *  Copyright  2006  User
 *  Email
 ****************************************************************************/

#ifndef _GUYUM_MAIN_H
#define _GUYUM_MAIN_H

#ifdef __cplusplus
extern "C"
{
#endif
	#include <include/guyum/gy_utils.h>
	#include <include/guyum.h>
	#include <include/guyum/gy_repo_list.h>
	#include <include/functions.h>
	#include <python2.4/Python.h>

	
/****************************************************************************
* GOBject-Macros															
****************************************************************************/
#define GUYUM_TYPE_MAIN	(guyum_main_get_type())
	
#define GUYUM_MAIN(object)	\
		(G_TYPE_CHECK_INSTANCE_CAST((object), GUYUM_TYPE_MAIN, GuyumMain))
	
#define GUYUM_MAIN_CLASS(klass)	\
		(G_TYPE_CHECK_CLASS_CAST((klass), GUYUM_TYPE_MAIN, GuyumMainClass))
	
#define GUYUM_IS_MAIN(object)	\
		(G_TYPE_CHECK_INSTANCE_TYPE((object), GUYUM_TYPE_MAIN))
	
#define GUYUM_IS_MAIN_CLASS(klass)	\
		(G_TYPE_CHECK_CLASS_TYPE ((klass), GUYUM_TYPE_MAIN))
	
#define GUYUM_MAIN_GET_CLASS(object)  \
		(G_TYPE_INSTANCE_GET_CLASS ((object), GUYUM_MAIN, GuyumMainClass))

	
#define GUYUM_MAIN_TYPE(object)	\
		(G_TYPE_FROM_INSTANCE(object))
		
#define GUYUM_MAIN_TYPE_NAME(object)	\
		(g_type_name(GUYUM_MAIN_TYPE(object)))


/****************************************************************************
* class
****************************************************************************/

	typedef struct _GuyumMain 		GuyumMain;
	typedef struct _GuyumMainClass 	GuyumMainClass;
	typedef struct _GuyumMainPrivate GuyumMainPrivate;
		
	struct _GuyumMain {
		GObject parent_instance;
		/* private */
		GuyumMainPrivate *priv;
	};
	
	struct _GuyumMainClass {
		GObjectClass parent_class;
		void (*destroy) (GuyumMain *archive);
	};

	/**
	* struct _GuyumMainPrivate
	* Contains guyummain properties.
	*/
	struct _GuyumMainPrivate {
		GuyumRepoComposite* repos;
		PyObject *yumquery_repos;
		
		gchar* logfilename;
		int logfile;
		gint threshold;
		
		GuyumQueryComposite* queries;	/**<  */
		PyObject *yumquery_module;	/**<  */
		PyObject *yumquery_dict;
		PyObject *yumquery_class;
		PyObject *yumquery_instance;
		char* yumquery_function_init;
		char *yumquery_function_search;
		
		GuyumInstallComponent* install;
				
	};

/****************************************************************************
* typical functions															
****************************************************************************/
	
	GType guyum_main_get_type(void);
	void guyum_main_destroy(GuyumMain* main);
	
/****************************************************************************
* main functions															
****************************************************************************/	
	gboolean guyum_main_add_query(GuyumMain *self, const gchar* query);
	
	GuyumPackageComposite* guyum_main_execute_query(GuyumMain *self, 
												GuyumQueryComponent* newquery,
												const gchar* query,
												GList* searchlist, 
												gchar* repoid);
	
	void guyum_main_execute_install(GuyumMain* self, int query_component_nth);
	
	void guyum_main_show_repositories(GuyumMain *self);
	
	gchar* guyum_main_get_repo_property(GuyumMain* self, const gchar* repoid, const gchar* property);
	
	GuyumPackageComposite* guyum_main_finddeps(GuyumMain *self, 
												int query_component_nth, 
												const gchar* packageid);
	
	gchar* 
	guyum_main_get_totalamount(GuyumMain *self, int query_component_nth);
	
	GuyumQueryComponent* guyum_main_init_query(GuyumMain *self,
												gint position);
	GuyumQueryComponent* guyum_main_get_nth_query(GuyumMain *self,
												gint position);
	GuyumPackageComposite* guyum_main_get_nth_packages(GuyumMain *self,
												gint position);
												
GuyumPackageComposite* guyum_main_rpmdbsearch(GuyumMain* self,
											    int query_component_nth,
                                                gchar* repoid);
												
	gint guyum_main_get_query_position(GuyumMain *self,
									GuyumQueryComponent* query);
									
	void 
	guyum_main_remove_nth_query(GuyumMain *self, 
								GuyumQueryComponent* query);
									
												
	

#ifdef __cplusplus
}
#endif

#endif /* _GUYUM_MAIN_H */
