/***************************************************************************
 *            guyum_package_component.h
 *
 *  Sat May 20 20:00:44 2006
 *  Copyright  2006  User
 *  Email
 ****************************************************************************/

#ifndef _GUYUM_PACKAGE_COMPONENT_H
#define _GUYUM_PACKAGE_COMPONENT_H

#ifdef __cplusplus
extern "C"
{
#endif

	
	#include <gtk/gtk.h>
	#include <glib/gprintf.h>
	#include <python2.4/Python.h>
	#include <include/guyum/gy_utils.h>
	
/****************************************************************************
* GOBject-Macros															
****************************************************************************/
#define GUYUM_TYPE_PACKAGE_COMPONENT	(guyum_package_component_get_type())
	
#define GUYUM_PACKAGE_COMPONENT(object)	\
		(G_TYPE_CHECK_INSTANCE_CAST((object), GUYUM_TYPE_PACKAGE_COMPONENT, GuyumPackageComponent))
	
#define GUYUM_PACKAGE_COMPONENT_CLASS(klass)	\
		(G_TYPE_CHECK_CLASS_CAST((klass), GUYUM_TYPE_PACKAGE_COMPONENT, GuyumPackageComponentClass))
	
#define GUYUM_IS_PACKAGE_COMPONENT(object)	\
		(G_TYPE_CHECK_INSTANCE_TYPE((object), GUYUM_TYPE_PACKAGE_COMPONENT))
	
#define GUYUM_IS_PACKAGE_COMPONENT_CLASS(klass)	\
		(G_TYPE_CHECK_CLASS_TYPE ((klass), GUYUM_TYPE_PACKAGE_COMPONENT))
	
#define GUYUM_PACKAGE_COMPONENT_GET_CLASS(object)  \
		(G_TYPE_INSTANCE_GET_CLASS ((object), GUYUM_PACKAGE_COMPONENT, GuyumPackageComponentClass))

	
#define GUYUM_PACKAGE_COMPONENT_TYPE(object)	\
		(G_TYPE_FROM_INSTANCE(object))
		
#define GUYUM_PACKAGE_COMPONENT_TYPE_NAME(object)	\
		(g_type_name(GUYUM_PACKAGE_COMPONENT_TYPE(object)))


/****************************************************************************
* class
****************************************************************************/

	typedef struct _GuyumPackageComponent 		GuyumPackageComponent;
	typedef struct _GuyumPackageComponentClass 	GuyumPackageComponentClass;
	typedef struct _GuyumPackageComponentPrivate GuyumPackageComponentPrivate;
		
	struct _GuyumPackageComponent {
		GObject parent_instance;
		/* private */
		GuyumPackageComponentPrivate *priv;
	};
	
	struct _GuyumPackageComponentClass {
		GObjectClass parent_class;
		void (*destroy) (GuyumPackageComponent *archive);
	};

	/**
	* struct _GuyumPackageComponentPrivate
	* Contains archive properties.
	*/
	struct _GuyumPackageComponentPrivate {
		gchar *arch;
		gchar *changelog;
		gchar *compsize;
		GList *conflicts;
		gchar *description;
		gchar *epoch;
		GList *files;
		gchar *group;
		gchar *licenses;
		gchar *localrelease;
		gchar *localversion; /**< Package version */		
		gchar *name;	/**< Package name */
		GList *obsoletes;
		gchar *packageid; /**< Package ID */
		gchar *pkgsize;
		GList *provides;
		gchar *release;
		gchar *remoterelease;
		gchar *remoteversion; /**< Package version */
		gchar *repoid;
		GList *requires;
		gchar *state;
		gchar *summary;
		gchar *url;
		gchar *version; /**< Package version */
		gchar *vendor;
		
		PyObject* yumpackage;
	};

/****************************************************************************
* typical functions															
****************************************************************************/
	
	GType guyum_package_component_get_type(void);
	void guyum_package_component_destroy(GuyumPackageComponent* package);

	
/****************************************************************************
* package functions															
****************************************************************************/	
	
#ifdef __cplusplus
}
#endif

#endif /* _GUYUM_PACKAGE_COMPONENT_H */
