/***************************************************************************
 *            guyum_package_composite.h
 *
 *  $LastChangedDate: 2005-12-26 17:24:46 +0100 (Mo, 26 Dez 2005) $
 *  Copyright  2005  $Author: vklein $
 *  Email
 ****************************************************************************/

#ifndef _GUYUM_PACKAGE_COMPOSITE_H
#define _GUYUM_PACKAGE_COMPOSITE_H

#ifdef __cplusplus
extern "C"
{
#endif

    #include <include/guyum/gy_package.h>
    #include <include/guyum/gy_utils.h>

/****************************************************************************
* GOBject-Macros															
****************************************************************************/	
	#define GUYUM_TYPE_PACKAGE_COMPOSITE	(guyum_package_composite_get_type())
	
	#define GUYUM_PACKAGE_COMPOSITE(object)	\
		(G_TYPE_CHECK_INSTANCE_CAST((object), GUYUM_TYPE_PACKAGE_COMPOSITE, GuyumPackageComposite))
	
	#define GUYUM_PACKAGE_COMPOSITE_CLASS(klass)	\
		(G_TYPE_CHECK_CLASS_CAST((klass), GUYUM_TYPE_PACKAGE_COMPOSITE, GuyumPackageCompositeClass))
	
	#define GUYUM_IS_PACKAGE_COMPOSITE(object)	\
		(G_TYPE_CHECK_INSTANCE_TYPE((object), GUYUM_TYPE_PACKAGE_COMPOSITE))
	
	#define GUYUM_IS_PACKAGE_COMPOSITE_CLASS(klass)	\
		(G_TYPE_CHECK_CLASS_TYPE ((klass), GUYUM_TYPE_PACKAGE_COMPOSITE))
	
	#define GUYUM_PACKAGE_COMPOSITE_GET_CLASS(object)  \
		(G_TYPE_INSTANCE_GET_CLASS ((object), GUYUM_PACKAGE_COMPOSITE, GuyumPackageCompositeClass))

	
	#define GUYUM_PACKAGE_COMPOSITE_TYPE(object)	\
		(G_TYPE_FROM_INSTANCE(object))
		
	#define GUYUM_PACKAGE_COMPOSITE_TYPE_NAME(object)	\
		(g_type_name(GUYUM_PACKAGE_COMPOSITE_TYPE(object)))

/****************************************************************************
* class
****************************************************************************/
	typedef struct _GuyumPackageComposite GuyumPackageComposite;
	typedef struct _GuyumPackageCompositeClass GuyumPackageCompositeClass;
	typedef struct _GuyumPackageCompositePrivate GuyumPackageCompositePrivate;
		
	struct _GuyumPackageComposite {
		GObject parent_instance;
		/* private */
		GuyumPackageCompositePrivate *priv;
	};
	
	struct _GuyumPackageCompositeClass {
		GObjectClass parent_class;
		void (*destroy) (GuyumPackageComposite *package_composite);
	};
	
	struct _GuyumPackageCompositePrivate {
		gint components_count;
		GList *package_components;
	};
	
/****************************************************************************
* typical functions															
****************************************************************************/
	GType guyum_package_composite_get_type(void);
	void guyum_package_composite_destroy(GuyumPackageComposite *package_composite);
	
/****************************************************************************
* composite functions															
****************************************************************************/
	void guyum_package_composite_add_component(	GuyumPackageComposite *package_composite,
													GuyumPackageComponent *package,
												gboolean* added);		
	void guyum_package_composite_remove_component(	GuyumPackageComposite *package_composite,
														GuyumPackageComponent *package);	
	gint guyum_package_composite_get_component_count(GuyumPackageComposite *package_composite);	
	GuyumPackageComponent *guyum_package_composite_get_nth_component(GuyumPackageComposite *package_composite, gint position);

	GuyumPackageComponent *guyum_package_composite_get_id_component(GuyumPackageComposite *package_composite,
																	const gchar* packageid) ;

	
	void 
	guyum_package_composite_remove_doubles(GuyumPackageComposite *self);

#ifdef __cplusplus
}
#endif

#endif /* _GUYUM_PACKAGE_COMPOSITE_H */
