/***************************************************************************
 *            guyum_query_component.h
 *
 *  $LastChangedDate: 2005-12-26 17:24:46 +0100 (Mo, 26 Dez 2005) $
 *  Copyright  2005  $Author: vklein $
 *  Email
 ****************************************************************************/

#ifndef _GUYUM_QUERY_COMPONENT_H
#define _GUYUM_QUERY_COMPONENT_H

#ifdef __cplusplus
extern "C"
{
#endif

	#include <gtk/gtk.h>
	#include <glib/gprintf.h>	
	#include <include/guyum/gy_package_list.h>
	#include <python2.4/Python.h>
	#include <include/guyum/gy_utils.h>
	#include <include/functions.h>

	
/****************************************************************************
* GOBject-Macros															
****************************************************************************/
	#define GUYUM_TYPE_QUERY_COMPONENT	(guyum_query_component_get_type())
	
	#define GUYUM_QUERY_COMPONENT(object)	\
		(G_TYPE_CHECK_INSTANCE_CAST((object), GUYUM_TYPE_QUERY_COMPONENT, GuyumQueryComponent))
	
	#define GUYUM_QUERY_COMPONENT_CLASS(klass)	\
		(G_TYPE_CHECK_CLASS_CAST((klass), GUYUM_TYPE_QUERY_COMPONENT, GuyumQueryComponentClass))
	
	#define GUYUM_IS_QUERY_COMPONENT(object)	\
		(G_TYPE_CHECK_INSTANCE_TYPE((object), GUYUM_TYPE_QUERY_COMPONENT))
	
	#define GUYUM_IS_QUERY_COMPONENT_CLASS(klass)	\
		(G_TYPE_CHECK_CLASS_TYPE ((klass), GUYUM_TYPE_QUERY_COMPONENT))
	
	#define GUYUM_QUERY_COMPONENT_GET_CLASS(object)  \
		(G_TYPE_INSTANCE_GET_CLASS ((object), GUYUM_QUERY_COMPONENT, GuyumQueryComponentClass))

	
	#define GUYUM_QUERY_COMPONENT_TYPE(object)	\
		(G_TYPE_FROM_INSTANCE(object))
		
	#define GUYUM_QUERY_COMPONENT_TYPE_NAME(object)	\
		(g_type_name(GUYUM_QUERY_COMPONENT_TYPE(object)))

/****************************************************************************
* class
****************************************************************************/
	typedef struct _GuyumQueryComponent 		GuyumQueryComponent;
	typedef struct _GuyumQueryComponentClass 	GuyumQueryComponentClass;
	typedef struct _GuyumQueryComponentPrivate GuyumQueryComponentPrivate;
		
	struct _GuyumQueryComponent {
		GObject parent_instance;
		/* private */
		GuyumQueryComponentPrivate *priv;
	};
	
	struct _GuyumQueryComponentClass {
		GObjectClass parent_class;
		void (*destroy) (GuyumQueryComponent *query);
	};
	
	struct _GuyumQueryComponentPrivate {
		int id;
		gchar* searchstring;	
            
		
		GuyumPackageComposite* packages;
		GuyumPackageComposite* deps;		
		
		PyObject *yumquery_packages;
		PyObject *yumquery_deps;
		
		PyObject *yumquery_module;	/**<  */
		PyObject *yumquery_dict;
		PyObject *yumquery_class;
		PyObject *yumquery_instance;
		gboolean renew;
	};
	

/****************************************************************************
* typical functions															
****************************************************************************/	
	GType guyum_query_component_get_type(void);
	void guyum_query_component_destroy(GuyumQueryComponent* query);

/****************************************************************************
* query component functions															
****************************************************************************/
	gy_status_t guyum_query_component_search(GuyumQueryComponent* self, 
														const gchar* query, 
														GList* searchlist, 
														gchar* repoid);
		
	PyObject*
	guyum_query_component_get_package(GuyumQueryComponent* self,
										const gchar* packageid);
	
	void
	guyum_query_setlog(GuyumQueryComponent* query, gchar* filename, gint threshold);

    void 
    guyum_query_component_rpmdbsearch(GuyumQueryComponent* self, gchar* repoid);
	
	#define GY_QUERY_FAILED 100

	
#ifdef __cplusplus
}
#endif

#endif /* _GUYUM_QUERY_COMPONENT_H */
