/***************************************************************************
 *            guyum_query_composite.h
 *
 *  $LastChangedDate: 2005-12-26 17:24:46 +0100 (Mo, 26 Dez 2005) $
 *  Copyright  2005  $Author: vklein $
 *  Email
 ****************************************************************************/

#ifndef _GUYUM_QUERY_COMPOSITE_H
#define _GUYUM_QUERY_COMPOSITE_H

#ifdef __cplusplus
extern "C"
{
#endif

    #include <include/guyum/gy_query.h>
    #include <include/guyum/gy_utils.h>

/****************************************************************************
* GOBject-Macros															
****************************************************************************/	
	#define GUYUM_TYPE_QUERY_COMPOSITE	(guyum_query_composite_get_type())
	
	#define GUYUM_QUERY_COMPOSITE(object)	\
		(G_TYPE_CHECK_INSTANCE_CAST((object), GUYUM_TYPE_QUERY_COMPOSITE, GuyumQueryComposite))
	
	#define GUYUM_QUERY_COMPOSITE_CLASS(klass)	\
		(G_TYPE_CHECK_CLASS_CAST((klass), GUYUM_TYPE_QUERY_COMPOSITE, GuyumQueryCompositeClass))
	
	#define GUYUM_IS_QUERY_COMPOSITE(object)	\
		(G_TYPE_CHECK_INSTANCE_TYPE((object), GUYUM_TYPE_QUERY_COMPOSITE))
	
	#define GUYUM_IS_QUERY_COMPOSITE_CLASS(klass)	\
		(G_TYPE_CHECK_CLASS_TYPE ((klass), GUYUM_TYPE_QUERY_COMPOSITE))
	
	#define GUYUM_QUERY_COMPOSITE_GET_CLASS(object)  \
		(G_TYPE_INSTANCE_GET_CLASS ((object), GUYUM_QUERY_COMPOSITE, GuyumQueryCompositeClass))

	
	#define GUYUM_QUERY_COMPOSITE_TYPE(object)	\
		(G_TYPE_FROM_INSTANCE(object))
		
	#define GUYUM_QUERY_COMPOSITE_TYPE_NAME(object)	\
		(g_type_name(GUYUM_QUERY_COMPOSITE_TYPE(object)))

/****************************************************************************
* class
****************************************************************************/
	typedef struct _GuyumQueryComposite GuyumQueryComposite;
	typedef struct _GuyumQueryCompositeClass GuyumQueryCompositeClass;
	typedef struct _GuyumQueryCompositePrivate GuyumQueryCompositePrivate;
		
	struct _GuyumQueryComposite {
		GObject parent_instance;
		/* private */
		GuyumQueryCompositePrivate *priv;
	};
	
	struct _GuyumQueryCompositeClass {
		GObjectClass parent_class;
		void (*destroy) (GuyumQueryComposite *query_composite);
	};
	
	struct _GuyumQueryCompositePrivate {
		gint components_count;
		GList *query_components;
	};
	
/****************************************************************************
* typical functions															
****************************************************************************/
	GType guyum_query_composite_get_type(void);
	void guyum_query_composite_destroy(GuyumQueryComposite *query_composite);
	
/****************************************************************************
* composite functions															
****************************************************************************/
	void guyum_query_composite_add_component(	GuyumQueryComposite *query_composite,
													GuyumQueryComponent *query);	
	
	void guyum_query_composite_insert_component(GuyumQueryComposite *query_composite,
												GuyumQueryComponent *query,
												gint position);	
	
	
	void guyum_query_composite_remove_component(	GuyumQueryComposite *query_composite,
														GuyumQueryComponent *query);	
	gint guyum_query_composite_get_component_count(GuyumQueryComposite *query_composite);	
	GuyumQueryComponent *guyum_query_composite_get_nth_component(GuyumQueryComposite *query_composite, gint position);

	GuyumPackageComposite* guyum_query_composite_execute_component(GuyumQueryComposite *query_composite, 
																	GuyumQueryComponent *query, 
																	GList* searchlist, 
																	gchar* repoid);
																	
	void
	guyum_query_composite_set_renew(GuyumQueryComposite* self, gint currentquery);	
	
	gboolean
	guyum_query_composite_get_renew(GuyumQueryComposite* self, gint currentquery);
	
#ifdef __cplusplus
}
#endif

#endif /* _GUYUM_QUERY_COMPOSITE_H */
