/***************************************************************************
 *            guyum_repo_component.h
 *
 *  $LastChangedDate: 2005-12-26 17:24:46 +0100 (Mo, 26 Dez 2005) $
 *  Copyright  2005  $Author: vklein $
 *  Email
 ****************************************************************************/

#ifndef _GUYUM_REPO_COMPONENT_H
#define _GUYUM_REPO_COMPONENT_H

#ifdef __cplusplus
extern "C"
{
#endif

	#include <gtk/gtk.h>
	#include <glib/gprintf.h>	
	#include <include/guyum/gy_utils.h>
	
/****************************************************************************
* GOBject-Macros															
****************************************************************************/
	#define GUYUM_TYPE_REPO_COMPONENT	(guyum_repo_component_get_type())
	
	#define GUYUM_REPO_COMPONENT(object)	\
		(G_TYPE_CHECK_INSTANCE_CAST((object), GUYUM_TYPE_REPO_COMPONENT, GuyumRepoComponent))
	
	#define GUYUM_REPO_COMPONENT_CLASS(klass)	\
		(G_TYPE_CHECK_CLASS_CAST((klass), GUYUM_TYPE_REPO_COMPONENT, GuyumRepoComponentClass))
	
	#define GUYUM_IS_REPO_COMPONENT(object)	\
		(G_TYPE_CHECK_INSTANCE_TYPE((object), GUYUM_TYPE_REPO_COMPONENT))
	
	#define GUYUM_IS_REPO_COMPONENT_CLASS(klass)	\
		(G_TYPE_CHECK_CLASS_TYPE ((klass), GUYUM_TYPE_REPO_COMPONENT))
	
	#define GUYUM_REPO_COMPONENT_GET_CLASS(object)  \
		(G_TYPE_INSTANCE_GET_CLASS ((object), GUYUM_REPO_COMPONENT, GuyumRepoComponentClass))

	
	#define GUYUM_REPO_COMPONENT_TYPE(object)	\
		(G_TYPE_FROM_INSTANCE(object))
		
	#define GUYUM_REPO_COMPONENT_TYPE_NAME(object)	\
		(g_type_name(GUYUM_REPO_COMPONENT_TYPE(object)))

/****************************************************************************
* class
****************************************************************************/
	typedef struct _GuyumRepoComponent 		GuyumRepoComponent;
	typedef struct _GuyumRepoComponentClass 	GuyumRepoComponentClass;
	typedef struct _GuyumRepoComponentPrivate GuyumRepoComponentPrivate;
		
	struct _GuyumRepoComponent {
		GObject parent_instance;
		/* private */
		GuyumRepoComponentPrivate *priv;
	};
	
	struct _GuyumRepoComponentClass {
		GObjectClass parent_class;
		void (*destroy) (GuyumRepoComponent *repo);
	};
	
	struct _GuyumRepoComponentPrivate {
		gboolean enabled;
		gchar* id;
		gchar* name;
	};

/****************************************************************************
* typical functions															
****************************************************************************/	
	GType guyum_repo_component_get_type(void);
	void guyum_repo_component_destroy(GuyumRepoComponent* repo);

/****************************************************************************
* repository component functions															
****************************************************************************/

	gchar* guyum_repo_component_get_py_property(GuyumRepoComponent* repo, const gchar* property);

#ifdef __cplusplus
}
#endif

#endif /* _GUYUM_REPO_COMPONENT_H */
