/***************************************************************************
 *            guyum_repo_composite.h
 *
 *  $LastChangedDate: 2005-12-26 17:24:46 +0100 (Mo, 26 Dez 2005) $
 *  Copyright  2005  $Author: vklein $
 *  Email
 ****************************************************************************/

#ifndef _GUYUM_REPO_COMPOSITE_H
#define _GUYUM_REPO_COMPOSITE_H

#ifdef __cplusplus
extern "C"
{
#endif
	
	#include <include/guyum/gy_repo.h>	
	#include <include/guyum/gy_utils.h>

/****************************************************************************
* GOBject-Macros															
****************************************************************************/	
	#define GUYUM_TYPE_REPO_COMPOSITE	(guyum_repo_composite_get_type())
	
	#define GUYUM_REPO_COMPOSITE(object)	\
		(G_TYPE_CHECK_INSTANCE_CAST((object), GUYUM_TYPE_REPO_COMPOSITE, GuyumRepoComposite))
	
	#define GUYUM_REPO_COMPOSITE_CLASS(klass)	\
		(G_TYPE_CHECK_CLASS_CAST((klass), GUYUM_TYPE_REPO_COMPOSITE, GuyumRepoCompositeClass))
	
	#define GUYUM_IS_REPO_COMPOSITE(object)	\
		(G_TYPE_CHECK_INSTANCE_TYPE((object), GUYUM_TYPE_REPO_COMPOSITE))
	
	#define GUYUM_IS_REPO_COMPOSITE_CLASS(klass)	\
		(G_TYPE_CHECK_CLASS_TYPE ((klass), GUYUM_TYPE_REPO_COMPOSITE))
	
	#define GUYUM_REPO_COMPOSITE_GET_CLASS(object)  \
		(G_TYPE_INSTANCE_GET_CLASS ((object), GUYUM_REPO_COMPOSITE, GuyumRepoCompositeClass))

	
	#define GUYUM_REPO_COMPOSITE_TYPE(object)	\
		(G_TYPE_FROM_INSTANCE(object))
		
	#define GUYUM_REPO_COMPOSITE_TYPE_NAME(object)	\
		(g_type_name(GUYUM_REPO_COMPOSITE_TYPE(object)))

/****************************************************************************
* class
****************************************************************************/
	typedef struct _GuyumRepoComposite GuyumRepoComposite;
	typedef struct _GuyumRepoCompositeClass GuyumRepoCompositeClass;
	typedef struct _GuyumRepoCompositePrivate GuyumRepoCompositePrivate;
		
	struct _GuyumRepoComposite {
		GObject parent_instance;
		/* private */
		GuyumRepoCompositePrivate *priv;
	};
	
	struct _GuyumRepoCompositeClass {
		GObjectClass parent_class;
		void (*destroy) (GuyumRepoComposite *repo_composite);
	};
	
	struct _GuyumRepoCompositePrivate {
		gint components_count;
		GList *repo_components;
	};
	
/****************************************************************************
* typical functions															
****************************************************************************/
	GType guyum_repo_composite_get_type(void);
	void guyum_repo_composite_destroy(GuyumRepoComposite *repo_composite);
	
/****************************************************************************
* composite functions															
****************************************************************************/
	void guyum_repo_composite_add_component(	GuyumRepoComposite *repo_composite,
													GuyumRepoComponent *repo);		
	void guyum_repo_composite_remove_component(	GuyumRepoComposite *repo_composite,
														GuyumRepoComponent *repo);	
	gint guyum_repo_composite_get_component_count(GuyumRepoComposite *repo_composite);	
	
	GuyumRepoComponent *guyum_repo_composite_get_nth_component(	GuyumRepoComposite *repo_composite, 
																gint position);

	GuyumRepoComponent *guyum_repo_composite_get_named_component(	GuyumRepoComposite *repo_composite, 
																	const gchar* repoid);


#ifdef __cplusplus
}
#endif

#endif /* _GUYUM_REPO_COMPOSITE_H */
