/***************************************************************************
 *            guyum_utils.h
 *
 *  Fri Oct 27 17:24:14 2006
 *  Copyright  2006  User
 *  Email
 ****************************************************************************/

#ifndef _GUYUM_UTILS_H
#define _GUYUM_UTILS_H

#ifdef __cplusplus
extern "C"
{
#endif
	
	#include <python2.4/Python.h>
	
	#define gy_status_t guint
	
	#define GY_SELF_IS_NULL 200
	#define GY_TYPE_FAILED 300
	#define GY_SUCCESS 0
		
	#define GOBJECT_INSTALL_STRING_PROPERTY(klass, propertyname, property) \
	{		\
		GParamSpec *param_spec;	\
		param_spec = g_param_spec_string(propertyname, "", "", "", G_PARAM_READWRITE); \
		g_object_class_install_property(gobject_class, property, param_spec);	\
	}

	#define GOBJECT_INSTALL_POINTER_PROPERTY(klass, propertyname, property) \
	{		\
		GParamSpec *param_spec;	\
		param_spec = g_param_spec_pointer(propertyname, "", "", G_PARAM_READWRITE); \
		g_object_class_install_property(gobject_class, property, param_spec);	\
	}
	
	

	#define GOBJECT_GET_STRING_PROPERTY(object, property, propvalue)  \
		 {					\
		GValue strvalue = {0,}; 										\
		g_value_init(&strvalue, G_TYPE_STRING); 						\
		g_object_get_property(G_OBJECT(object), property, &strvalue); 	\
		(*propvalue) = g_value_dup_string(&strvalue); 						\
		g_value_unset(&strvalue); 										\
	}

	
	#define GOBJECT_SET_STRING_PROPERTY(object, property, propvalue)  \
		 {					\
		GValue strvalue = {0,}; 										\
		g_value_init(&strvalue, G_TYPE_STRING); 						\
		g_value_set_string(&strvalue, propvalue);	\
		g_object_set_property(G_OBJECT(object), property, &strvalue); \
		g_value_unset(&strvalue); 										\
	}	

	#define GOBJECT_GET_POINTER_PROPERTY(object, property, propvalue)  \
		 {					\
		GValue ptrvalue = {0,}; 										\
		g_value_init(&ptrvalue, G_TYPE_POINTER); 						\
		g_object_get_property(G_OBJECT(object), property, &ptrvalue); 	\
		propvalue = g_value_get_pointer(&ptrvalue); 						\
		g_value_unset(&ptrvalue); 										\
	}
	
	#define GOBJECT_SET_POINTER_PROPERTY(object, property, propvalue)  \
		 {					\
		GValue ptrvalue = {0,}; 										\
		g_value_init(&ptrvalue, G_TYPE_POINTER); 						\
		g_value_set_pointer(&ptrvalue, propvalue);	\
		g_object_set_property(G_OBJECT(object), property, &ptrvalue); \
		g_value_unset(&ptrvalue); 										\
	}		
	
	#define GOBJECT_SET_BOOLEAN_PROPERTY(object, property)  \
		 {					\
		GValue boolvalue = {0,}; 										\
		g_value_init(&boolvalue, G_TYPE_BOOLEAN); 						\
		g_value_set_boolean(&boolvalue, TRUE);							\
		g_object_set_property(G_OBJECT(object), property, &boolvalue); \
		g_value_unset(&boolvalue); 										\
	}	
	
	#define GOBJECT_UNSET_BOOLEAN_PROPERTY(object, property)  \
		 {					\
		GValue boolvalue = {0,}; 										\
		g_value_init(&boolvalue, G_TYPE_BOOLEAN); 						\
		g_value_set_boolean(&boolvalue, FALSE);							\
		g_object_set_property(G_OBJECT(object), property, &boolvalue); \
		g_value_unset(&boolvalue); 										\
	}
	
	#define GOBJECT_GET_BOOLEAN_PROPERTY(object, property, propvalue)  \
		 {					\
		GValue boolvalue = {0,}; 										\
		g_value_init(&boolvalue, G_TYPE_BOOLEAN); 						\
		g_object_get_property(G_OBJECT(object), property, &boolvalue); 	\
		(*propvalue) = g_value_get_boolean(&boolvalue); 						\
		g_value_unset(&boolvalue); 										\
	}	
	
	#define GUYUM_PYTHON_FATAL_ERROR() \
		{	\
		PyObject* ptype;					\
		PyObject* pvalue;					\
		PyObject* ptraceback;				\
		PyObject *pystring = NULL;			\
		gchar* errormessage;				\
		gchar* typestring = NULL;					\
		gchar* valuestring = NULL;					\
											\
		PyObject* exception = PyErr_Occurred();	\
		if (exception!=NULL) {						\
			PyErr_Fetch(&ptype, &pvalue, &ptraceback);	\
														\
			if (ptype!=NULL && 							\
				(pystring = PyObject_Str(ptype))!=NULL && \
				PyString_Check(pystring)) {					\
				typestring = PyString_AsString(pystring);	\
			}												\
			pystring = NULL;								\
			if (pvalue!=NULL && 							\
				(pystring = PyObject_Str(pvalue))!=NULL &&	\
				PyString_Check(pystring)) {					\
				valuestring = PyString_AsString(pystring);	\
			}												\
															\
			errormessage = g_strconcat("An error occured!\nThe error message was: ", typestring, valuestring, NULL); \
															\
			show_error_dialog(errormessage);				\
															\
			Py_XDECREF(pystring);							\
			Py_XDECREF(ptype);								\
			Py_XDECREF(pvalue);								\
			Py_XDECREF(ptraceback);							\
			g_free(errormessage);							\
															\
		}													\
		exit(1);										\
	}

#ifdef __cplusplus
}
#endif

#endif /* _GUYUM_UTILS_H */
