/***************************************************************************
 *            callbacks.c
 *
 *  Sat Feb 18 11:08:05 2006
 *  Copyright  2006  User
 *  Email
 ****************************************************************************/
#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <include/callbacks.h>

extern GuyumMain* guyummain;
extern GladeXML* xml;
extern GtkWidget* window1;
extern GtkWidget* logdialog;
extern GdkCursor* cursor;
extern GtkWidget* depsdialog;
extern GtkWidget* installokdialog;


GAsyncQueue* asyncqueue;

void
on_guyum_button_search_clicked(GtkButton* button, gpointer *user_data);

/**
*
*/
void
on_logdialog_button_close_clicked(GtkButton* button, gpointer *user_data)
{
	gtk_widget_hide(logdialog);
}


/**
*
*/
void
on_guyum_entry_search_activate(GtkEntry* entry, gpointer* user_data)
{
	GtkButton* searchbutton = GTK_BUTTON(glade_xml_get_widget(xml, "guyum_button_search"));
	on_guyum_button_search_clicked(searchbutton, user_data);	
}

/**
*
*/
void
on_guyum_notebook_query_switch_page(GtkNotebook* notebook_query, 
									GtkNotebookPage* child, 
									guint page_num, 
									gpointer user_data)
{
	GtkTreeIter treepath ;
	GtkTreeView* treeview ;
	GtkTreeModel* treemodel ;
	GtkTreeSelection* selection;
	GuyumQueryComponent* query;	
	
	treeview = get_nth_query_treeview(notebook_query, page_num);	
	
	treemodel = gtk_tree_view_get_model(treeview);
	selection = gtk_tree_view_get_selection(treeview);
	if (treemodel!=NULL) {
		if (gtk_tree_model_get_iter_first(treemodel, &treepath)) {	
			
			gtk_tree_selection_select_iter(selection, &treepath);
			query = guyum_main_get_nth_query(guyummain, page_num);
			query_selection_changed(selection, (gpointer)query);
		}
	}
	
}


/**
*
*/
void
on_deps_button_cancel_clicked(GtkButton* button, gpointer* user_data)
{	
	cancel_depsdialog();
}

/**
*
*/
void
on_guyum_button_showlog_clicked(GtkButton* button, gpointer *user_data)
{
	gchar* logfilename = NULL;
	
	GOBJECT_GET_STRING_PROPERTY(guyummain, "logfilename", &logfilename);
	
	read_logfile_into_textview(logfilename);
	if (!GTK_WIDGET_VISIBLE(logdialog)) {
		gtk_widget_show(logdialog);
	}
	g_free(logfilename);
}

/**
*
*/
void
on_guyum_button_quit_clicked(GtkButton* button, gpointer *user_data)
{
	gtk_main_quit();
}

/**
*
*/
void on_quit2_activate(GtkMenuItem* menuitem, gpointer *user_data) 
{
	on_guyum_button_quit_clicked(NULL, user_data);
}
	
/**
*
*/
void on_about2_activate(GtkMenuItem* menuitem, gpointer *user_data)
{
	GtkWidget* about_dialog = glade_xml_get_widget(xml, "aboutdialog");

	gint status = gtk_dialog_run(GTK_DIALOG(about_dialog));
	switch (status) {
		case GTK_RESPONSE_CLOSE:
			gtk_widget_hide(about_dialog);
			break;
		case GTK_RESPONSE_DELETE_EVENT:
			gtk_widget_hide(about_dialog);
			break;
		case GTK_RESPONSE_CANCEL:
			gtk_widget_hide(about_dialog);
			break;
		default:
			gtk_widget_hide(about_dialog);
			break;
	}
}

/**
*
*/
void
on_guyum_button_repoedit_clicked(GtkButton* button, gpointer *user_data)
{
	GtkDialog *repoedit_dialog = (GtkDialog*)glade_xml_get_widget(xml, "guyum_dialog_repo");
	GtkTreeView *treeview_repo = (GtkTreeView*)glade_xml_get_widget(xml, "dlgrepo_treeview_repo");
	GtkTreeView *repos = (GtkTreeView*)glade_xml_get_widget(xml, "guyum_treeview_repo");
	GtkTreeModel     *model;
    GtkTreeIter      iter;
	gchar* repoid = NULL;
	
	GuyumRepoComposite* repo_composite;
	
	if (gtk_tree_selection_get_selected(gtk_tree_view_get_selection(repos), &model, &iter)) {
		GuyumRepoComponent* repository;
		
		gtk_tree_model_get (model, &iter, COL_REPOS_ID, &repoid, -1);			
		GOBJECT_GET_POINTER_PROPERTY(guyummain, "repos", repo_composite);
		
		repository = guyum_repo_composite_get_named_component(repo_composite, repoid);		
		create_repoprops_treemodel(&treeview_repo, repoid);
		repoprops_create_and_fill_model(repoid, treeview_repo);
		
		gtk_widget_show(GTK_WIDGET(repoedit_dialog));

	} else {
		show_error_dialog(_("Error: please choose a repository!"));
	}
	
	
	/* Free variables */
	g_free(repoid);
}

/**
*
*/
void
on_repodlg_button_close_clicked(GtkButton* button, gpointer *user_data)
{
	GtkWidget *repoedit_dialog = glade_xml_get_widget(xml, "guyum_dialog_repo");
	gtk_widget_hide(repoedit_dialog);
}

/**
*
*/
void
on_deps_button_ok_clicked(GtkButton* button, gpointer *user_data)
{
	GError* error;
	write_into_textbuffer(GTK_TEXT_VIEW(glade_xml_get_widget(xml, "details_textview")), "");
	SET_CURSOR;	
	g_thread_create_full((GThreadFunc)run_dialog_thread, (gpointer*)_("Installation in progress..."), 0, FALSE, FALSE, G_THREAD_PRIORITY_LOW, &error);	
	g_thread_create_full((GThreadFunc)execute_install, NULL, 0, TRUE, FALSE, G_THREAD_PRIORITY_LOW, &error);		
}


/**
*
*/
void
on_guyum_button_install_clicked(GtkButton* button, gpointer *user_data)
{
	GtkTreeView *treeview;
  	GtkTreeModel     *model;
  	GtkTreeIter       iter;
	gchar* package = NULL;
	gchar* version = NULL;
	gchar* repoid = NULL;
	gchar* pkgid = NULL;
	GtkTreeSelection *selection;
	GtkNotebook* notebook_query;	
	gchar *waittext;
	GError* error = NULL;
	
	notebook_query = (GtkNotebook*)glade_xml_get_widget(xml, "guyum_notebook_query");
	
	treeview = get_nth_query_treeview(notebook_query, gtk_notebook_get_current_page(notebook_query));
	
	selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(treeview));
	
	if (gtk_tree_selection_get_selected(selection, &model, &iter)) {
		gtk_tree_model_get (model, &iter, COL_PACKAGE_NAME, &package, -1);
		gtk_tree_model_get (model, &iter, COL_PACKAGE_REMOTEVERSION, &version, -1);
		gtk_tree_model_get (model, &iter, COL_PACKAGE_REPOID, &repoid, -1);
		
		gtk_tree_model_get (model, &iter, COL_PACKAGE_PKGID, &pkgid, -1);
	}
	
	waittext = g_strdup_printf(_("Resolving dependencies for %s-%s from %s\n"), package, version, repoid);	

	g_thread_create_full((GThreadFunc)run_installwait_dialog_thread, (gpointer*)waittext, 0, FALSE, FALSE, G_THREAD_PRIORITY_LOW, &error);

	g_thread_create_full((GThreadFunc)run_preinstall_thread, (gpointer*)pkgid, 0, FALSE, FALSE, G_THREAD_PRIORITY_LOW, &error);					
	
	/*execute_preinstall((gpointer*)pkgid);*/
	/* Free variables */
	g_free(package);
	g_free(version);
	g_free(repoid);
	//g_free(pkgid);
	//g_free(waittext);

}



/**
*
*/
void
on_guyum_button_search_clicked(GtkButton* button, gpointer *user_data)
{

	GError* error;	
	GList* repos;
	GList* searchlist;

	GtkWidget* searchlabel = glade_xml_get_widget(xml, "guyum_label_startsearch");	
	GtkEntry* searchentry = GTK_ENTRY(glade_xml_get_widget(xml, "guyum_entry_search"));
	if (gtk_entry_get_text(searchentry)==NULL || g_strcasecmp("", gtk_entry_get_text(searchentry))==0) {
		show_error_dialog(_("Please specify a search query"));
		g_return_if_fail(FALSE);
	}	
	
	repos = get_repositories();
	if (g_list_length(repos)==0) {
		show_error_dialog(_("Please specify at least one repository"));
		g_return_if_fail(FALSE);
	}
	
	searchlist = get_searchfields();
	if (g_list_length(searchlist)==0) {
		show_error_dialog(_("Please specify at least one searchfield"));
		g_return_if_fail(FALSE);
	}
	
	
	if (GTK_WIDGET_VISIBLE(searchlabel)) {
		gtk_widget_hide(searchlabel);	
	}
	
	asyncqueue = g_async_queue_new();	

	write_into_textbuffer(GTK_TEXT_VIEW(glade_xml_get_widget(xml, "details_textview")), _("Searching for..."));
	append_to_textbuffer(GTK_TEXT_VIEW(glade_xml_get_widget(xml, "details_textview")), (gchar*)gtk_entry_get_text(searchentry));
	append_to_textbuffer(GTK_TEXT_VIEW(glade_xml_get_widget(xml, "details_textview")), "\n");	
	
	g_thread_create_full((GThreadFunc)run_dialog_thread, (gpointer*)_("Please wait..."), 0, FALSE, FALSE, G_THREAD_PRIORITY_LOW, &error);
	g_async_queue_ref(asyncqueue);
	g_thread_create_full((GThreadFunc)search_thread, (gchar*)gtk_entry_get_text(searchentry), 0, TRUE, FALSE, G_THREAD_PRIORITY_LOW, &error);		
	g_async_queue_ref(asyncqueue);	
	
	g_list_free(repos);
	g_list_free(searchlist);
}

/**
*
*/
void
on_guyum_dialog_wait_button_cancel_clicked(GtkButton* button, gpointer *user_data)
{
	gint i = 1;
	if (g_async_queue_length(asyncqueue)==0) {
		g_async_queue_push(asyncqueue, (gpointer)i);
		append_to_textbuffer(GTK_TEXT_VIEW(glade_xml_get_widget(xml, "details_textview")), _("Cancelling search..."));
	}
}

/**
*
*/
void 
on_guyum_button_close_current_clicked(GtkButton* button, gpointer *user_data)
{
	GtkNotebook* notebook_query;
	GuyumQueryComponent* query = (GuyumQueryComponent*)user_data;
	gint pageindex = -1;
	
	notebook_query = GTK_NOTEBOOK(glade_xml_get_widget(xml, "guyum_notebook_query"));
	
	pageindex = guyum_main_get_query_position(guyummain, query);
	
	if (pageindex>-1) {
		gtk_notebook_remove_page(notebook_query, pageindex);
		guyum_main_remove_nth_query(guyummain, (GuyumQueryComponent*)user_data);
		
		if (gtk_notebook_get_nth_page(notebook_query, 0)==NULL) {
			GtkWidget* searchlabel = GTK_WIDGET(glade_xml_get_widget(xml, "guyum_label_startsearch"));
			gtk_widget_show(searchlabel);
		}
	}
}
