/***************************************************************************
 *            functions.c
 *
 *  Mon May 29 21:37:35 2006
 *  Copyright  2006  User
 *  Email
 ****************************************************************************/

#include <include/functions.h>
#include <time.h>


GladeXML *xml;
GtkWidget *window1;
GdkCursor* cursor;
GtkWidget* logdialog;


 
gboolean 
avoid_close_window(GtkWidget *widget,
					GdkEvent* event,
					gpointer data)
{
	return TRUE;	
}

/**
* show error dialog
*/
void
show_error_dialog (gchar * message)
{
	GtkWidget *dialog;
	if (xml!=NULL) {
		GtkWidget *main_application_window = glade_xml_get_widget(xml, "guyum_window_main");
		dialog = gtk_message_dialog_new (GTK_WINDOW (main_application_window),
					 GTK_DIALOG_MODAL,
					 GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE,
					 "%s", message);
		gtk_dialog_run (GTK_DIALOG (dialog));
		gtk_widget_destroy (dialog);
	}
}

void
read_logfile_into_textview(const gchar* logfilename)
{
	GError* error = NULL;
	GtkTextIter end; 
	GtkTextIter start;
	GtkTextBuffer* textbuffer; 
	GtkTextView* textview;	
	GIOStatus ret;
	gchar* str;
	gsize len;
	
	GIOChannel* logfile_channel = g_io_channel_new_file(logfilename, "r", &error);
	
	textview = (GtkTextView*)glade_xml_get_widget(xml, "guyum_logdialog_textview");
	
	textbuffer = gtk_text_view_get_buffer(textview); 
	gtk_text_buffer_get_start_iter(textbuffer, &start);
	gtk_text_buffer_get_end_iter(textbuffer, &end); 
	gtk_text_buffer_delete(textbuffer, &start, &end);		
	
	
	while ((ret =  g_io_channel_read_line(logfile_channel, &str, &len, NULL, &error))==G_IO_STATUS_NORMAL) {
		gtk_text_buffer_get_end_iter(textbuffer, &end); 
		gtk_text_buffer_insert(textbuffer, &end, str, -1); 	
	}
	g_free(str);
	
	
}

void 
append_textview_log(const gchar *message) 
{
}


void
write_into_textbuffer(GtkTextView* textview, const gchar* text)
{
	GtkTextBuffer* textbuffer;
	GtkTextIter starttextiter;
	GtkTextIter endtextiter;
	
	textbuffer = gtk_text_view_get_buffer(textview);
	gtk_text_buffer_get_start_iter(textbuffer, &starttextiter);
	gtk_text_buffer_get_end_iter(textbuffer, &endtextiter);
	gtk_text_buffer_delete(textbuffer, &starttextiter, &endtextiter);
	gtk_text_buffer_insert(textbuffer, &starttextiter, text, -1);
}

/**
* Schreibt ans Ende eines Textbuffers
*/
void
append_to_textbuffer(GtkTextView* textview, const gchar* text)
{
	GtkTextBuffer* textbuffer;
	GtkTextIter endtextiter;
	
	textbuffer = gtk_text_view_get_buffer(textview);
	gtk_text_buffer_get_end_iter(textbuffer, &endtextiter);
	gtk_text_buffer_insert(textbuffer, &endtextiter, text, -1);
}

/**
* Erstellt eine GList aus einer Python-Liste
*/
GList*
Py_List_As_GList(PyObject* py_list) {
	gint i = 0;
	GList* retlist = NULL;
	if (PyList_Check(py_list)) {
		for (i=0; i<PyList_Size(py_list); i++) {
			PyObject* py_object = PyList_GetItem(py_list, i);
			if (PyString_Check(py_object)) {
				retlist = g_list_append(retlist, PyString_AsString(py_object));
			} else {
				retlist = g_list_append(retlist, py_object);
			}
		}
	}
	return retlist;
}

/**
*
*/
GList* get_searchfields()
{
	GList* searchfields = NULL;
	/* get all founded packages and insert into treeview */
	if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(glade_xml_get_widget(xml, "guyum_checkbutton_name")))) {
		searchfields = g_list_append(searchfields, (gpointer)"name");
	}
	if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(glade_xml_get_widget(xml, "guyum_checkbutton_description")))) {
		searchfields = g_list_append(searchfields, (gpointer)"description");
	}
	return searchfields;	
}

/**
* Schreibt eine Liste in eine TreeView
*/
void
write_list_into_tree(GList* list, GtkTreeView* treeview, gchar* title)
{
	GtkTreeStore *treestore;
	GtkTreeIter toplevel;
	gint i = 0;
	GtkTreeViewColumn* column;
	GtkCellRenderer   *renderer = gtk_cell_renderer_text_new ();
	
	/* packages treestore */
	if ((treestore = GTK_TREE_STORE(gtk_tree_view_get_model(treeview)))==NULL) {
		treestore = gtk_tree_store_new(N_COLUMNS, G_TYPE_STRING);
	
		column = gtk_tree_view_column_new_with_attributes("", renderer, "text", TEXT_COLUMN, NULL);
	
		gtk_tree_view_append_column(treeview, column);
		gtk_tree_view_set_model(treeview, GTK_TREE_MODEL(treestore));
		
		g_object_unref(treestore);		
		gtk_widget_show(GTK_WIDGET(treeview));
		
	} else {
		gtk_tree_store_clear(GTK_TREE_STORE(treestore));
	}
	
	if (list!=NULL) {
		for (i=0; i<g_list_length(list); i++) {
			gchar *data = g_list_nth_data(list, i);
			gtk_tree_store_append(treestore, &toplevel, NULL);
			gtk_tree_store_set(treestore, &toplevel, 
								TEXT_COLUMN, data,
								-1);
		}
	}
	
}


void
cancel_depsdialog() 
{
	GtkWidget* depsdialog = GTK_WIDGET(glade_xml_get_widget(xml, "guyum_dialog_deps"));
	RESET_CURSOR;
	gtk_widget_hide(depsdialog);
}
