/* Created by Anjuta version 1.2.3 */
/*	This file will not be overwritten */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gnome.h>
#include <gtk/gtk.h>
#include <glade/glade.h>
#include <include/functions.h>
#include <include/callbacks.h>
#include <glib.h>
#include <glib/gstdio.h>

#include <include/guyum.h>
#include <include/callbacks.h>
#include <include/ui/ui_repotree.h>
#include <include/init.h>

extern GladeXML *xml;
extern GuyumMain* guyummain;
extern GtkWidget *window1;
extern GdkCursor* cursor;
extern GtkWidget* logdialog;
extern GtkWidget* depsdialog;
extern GtkWidget* installokdialog;

int main (int argc, char *argv[])
{
	gchar *logfilename = NULL ;
	GError *error = NULL;
	GtkWidget* initdialog = NULL; 
	
	#ifdef ENABLE_NLS
		bindtextdomain (GETTEXT_PACKAGE, PACKAGE_LOCALE_DIR);
		textdomain (PACKAGE);
	#endif

	  /* init threads */
	  g_thread_init(NULL);
	  gdk_threads_init();	
		
	  gtk_set_locale ();
	  gtk_init (&argc, &argv);	
	
	gnome_program_init("guyum", "0.2.1", LIBGNOMEUI_MODULE, argc, &argv, NULL);	
	
	/*
	 * The .glade filename should be on the next line.
	 */
	xml = glade_xml_new (PACKAGE_DATA_DIR"/"PACKAGE"/glade/guyum.glade", NULL, "guyum");	

	/* This is important */
	glade_xml_signal_autoconnect (xml);
	
	GtkWidget* querynotebook = (GtkWidget*)glade_xml_get_widget(xml, "guyum_notebook_query");
	gtk_notebook_remove_page(GTK_NOTEBOOK(querynotebook), 0);

	GtkWidget* depsnotebook = (GtkWidget*)glade_xml_get_widget(xml, "deps_notebook_packages");
	gtk_notebook_remove_page(GTK_NOTEBOOK(depsnotebook), 0);

	window1 = glade_xml_get_widget (xml, "guyum_window_main");
	
	g_signal_connect(G_OBJECT(window1), "destroy", gtk_main_quit, NULL);
	g_signal_connect(G_OBJECT(window1), "delete_event", gtk_main_quit, NULL);

	installokdialog = glade_xml_get_widget(xml, "guyum_dialog_installok");
	cursor = gdk_cursor_new_for_display(gtk_widget_get_display(window1), GDK_WATCH);
	gdk_window_set_cursor(window1->window, cursor);    
    
	gtk_widget_show (window1);	

	g_setenv("PYTHONPATH", PACKAGE_DATA_DIR"/"PACKAGE"/python", TRUE);
	append_to_textbuffer(GTK_TEXT_VIEW(glade_xml_get_widget(xml, "details_textview")), _("Initializing GuYum..."));
	
	g_file_open_tmp("guyumXXXXXX", &logfilename, &error);
	initdialog = GTK_WIDGET(glade_xml_get_widget(xml, "guyum_dialog_init"));
			
	gdk_threads_enter();	

	g_signal_connect(G_OBJECT(initdialog), "destroy", G_CALLBACK(avoid_close_window), NULL); 
	g_signal_connect(G_OBJECT(initdialog), "delete_event", G_CALLBACK(avoid_close_window), NULL);	
	
	gtk_widget_show(initdialog);
	
	g_timeout_add_full(G_PRIORITY_DEFAULT_IDLE, 100, (GSourceFunc)init_guyum, logfilename, (GDestroyNotify)init_notify);
	gtk_main ();		
	
	gdk_threads_leave();
	
	if (guyummain!=NULL) {
		guyum_main_destroy(guyummain);
	}
	
	if (g_file_test(logfilename, G_FILE_TEST_EXISTS)) {
		g_remove(logfilename);
	}	
	
	g_free(logfilename);
	
	return 0;
}
