/***************************************************************************
 *            t_repotest.c
 *
 *  Mon Feb  5 13:12:54 2007
 *  Copyright  2007  User
 *  Email
 ****************************************************************************/

#include "test_all.h"
#include <include/init.h>

static gchar* REPOID="localtest";
extern GuyumMain* guyummain;

/**
* Test for repository properties 
* TR1
*/
void TestSearch_RepoProps(CuTest* t)
{
	gchar* property = NULL;

	DEBUG_OUTPUT("Running repository properties tests...");
	DEBUG_OUTPUT("TR1");
	
	property = guyum_main_get_repo_property(guyummain, REPOID, "name");	
	CuAssertStrEquals(t, "localtest", property );		
	property = guyum_main_get_repo_property(guyummain, REPOID, "bandwidth");										
	CuAssertStrEquals(t, "0", property );
	property = guyum_main_get_repo_property(guyummain, REPOID, "enablegroups");
	CuAssertStrEquals(t, "True", property );
//	property = guyum_main_get_repo_property(guyummain, REPOID, "gpgcheck");										
//	CuAssertStrEquals(t, "0", property );
	property = guyum_main_get_repo_property(guyummain, REPOID, "includepkgs");										
	CuAssertStrEquals(t, "[]", property );
	property = guyum_main_get_repo_property(guyummain, REPOID, "keepalive");
	CuAssertStrEquals(t, "True", property );
	property = guyum_main_get_repo_property(guyummain, REPOID, "proxy");
	CuAssertStrEquals(t, "None", property );
	property = guyum_main_get_repo_property(guyummain, REPOID, "proxy_password");
	CuAssertStrEquals(t, "None", property );
	property = guyum_main_get_repo_property(guyummain, REPOID, "proxy_username");
	CuAssertStrEquals(t, "None", property );
	property = guyum_main_get_repo_property(guyummain, REPOID, "exclude");
	CuAssertStrEquals(t, "[]", property );
	property = guyum_main_get_repo_property(guyummain, REPOID, "retries");
	CuAssertStrEquals(t, "20", property );
	property = guyum_main_get_repo_property(guyummain, REPOID, "throttle");
	CuAssertStrEquals(t, "0", property );
	property = guyum_main_get_repo_property(guyummain, REPOID, "timeout");
	CuAssertStrEquals(t, "30.0", property );
	property = guyum_main_get_repo_property(guyummain, REPOID, "mirrorlist");
	CuAssertStrEquals(t, "None", property );
	property = guyum_main_get_repo_property(guyummain, REPOID, "cachedir");
	CuAssertStrEquals(t, "//var/cache/yum/localtest", property );
	property = guyum_main_get_repo_property(guyummain, REPOID, "gpgkey");
	CuAssertStrEquals(t, "", property );
	property = guyum_main_get_repo_property(guyummain, REPOID, "pkgdir");
	CuAssertStrEquals(t, "//var/cache/yum/localtest/packages", property );
	property = guyum_main_get_repo_property(guyummain, REPOID, "hdrdir");
	CuAssertStrEquals(t, "//var/cache/yum/localtest/headers", property );	
	
	DEBUG_OUTPUT("Done.\n");

	
}

CuSuite* make_repotest_suite(void)
{
	CuSuite *s=CuSuiteNew();	
	
	SUITE_ADD_TEST(s, TestSearch_RepoProps);
			
	return s;
}
