/***************************************************************************
 *            t_rpmdb.c
 *
 *  Sun Feb 11 20:48:15 2007
 *  Copyright  2007  User
 *  Email
 ****************************************************************************/

 
#include "test_all.h"
#include "test_utils.h"
#include <include/init.h>

static gchar* REPOID="localtest";
static gint globalcounter=0;
extern GuyumMain* guyummain;


/**
* Search for existing package
* TR10
*/
void TestSearch_RPMDBExistPack(CuTest* t)
{
	GList* namelist = NULL;
	GuyumPackageComposite* packages = NULL;
	GuyumPackageComponent* package = NULL;	
	GuyumQueryComposite* queries = NULL;
	GuyumQueryComponent* query = NULL;
	
	GValue strvalue={0,};
	GValue ptrvalue={0,};
	g_value_init(&strvalue, G_TYPE_STRING);
	g_value_init(&ptrvalue, G_TYPE_POINTER);
	
	DEBUG_OUTPUT("Running search for existing package");
	DEBUG_OUTPUT("TR10");	
	
	namelist = g_list_append(namelist, "name");
	
	/* Search for existing package */
	packages = runSearch("guyum-package-loc-rem", namelist, globalcounter, REPOID);	
	CuAssertPtrNotNull(t, packages);	
	
	package = guyum_package_composite_get_nth_component(packages, 0);	
	CuAssertPtrNotNull(t, package);
	
	guyum_main_rpmdbsearch(guyummain, globalcounter, REPOID);
	
	g_object_get_property(G_OBJECT(guyummain), "queries", &ptrvalue);	
	queries = g_value_get_pointer(&ptrvalue);
	CuAssertPtrNotNull(t, queries);	
	
	query = guyum_query_composite_get_nth_component(queries, globalcounter);
	CuAssertPtrNotNull(t, query);
	
	g_object_get_property(G_OBJECT(query), "packages", &ptrvalue);	
	packages = g_value_get_pointer(&ptrvalue);
	CuAssertPtrNotNull(t, packages);	
	
	package = guyum_package_composite_get_nth_component(packages, 0);	
	CuAssertPtrNotNull(t, package);
	
	g_object_get_property(G_OBJECT(package), "name", &strvalue);
	CuAssertStrEquals(t, "guyum-package-loc-rem", g_value_get_string(&strvalue));
	
	globalcounter++;	
	
	DEBUG_OUTPUT("Done.\n");

	g_value_unset(&strvalue);
	g_value_unset(&ptrvalue);
	
	g_list_free(namelist);	
	
}

/**
* Search for existing package
* TR20
*/
void TestSearch_RPMDBNotExistPack(CuTest* t)
{
	GList* namelist = NULL;
	GuyumPackageComposite* packages = NULL;
	
	GValue strvalue={0,};
	GValue ptrvalue={0,};
	g_value_init(&strvalue, G_TYPE_STRING);
	g_value_init(&ptrvalue, G_TYPE_POINTER);
	
	DEBUG_OUTPUT("Running search for not existing package");
	DEBUG_OUTPUT("TR20");	
	
	namelist = g_list_append(namelist, "name");
	
	/* Search for existing package */
	packages = runSearch("#spdofiaosf21+-sdf", namelist, globalcounter, REPOID);
	
	CuAssertPtrNotNull(t, packages);	
		
	guyum_main_rpmdbsearch(guyummain, globalcounter, REPOID);
	
	globalcounter++;	
	
	DEBUG_OUTPUT("Done.\n");

	g_value_unset(&strvalue);
	g_value_unset(&ptrvalue);
	
	g_list_free(namelist);	
	
}

CuSuite* make_rpmdbtest_suite(void)
{
	CuSuite *s=CuSuiteNew();	
	
	SUITE_ADD_TEST(s, TestSearch_RPMDBExistPack);
	SUITE_ADD_TEST(s, TestSearch_RPMDBNotExistPack);	
	return s;
}
