#include "test_all.h"
#include <unistd.h>

extern GuyumMain* guyummain;

int main(int argc, char *argv[])
{
	CuString *output;
	CuSuite *sr;
	
	output = CuStringNew();
	sr = CuSuiteNew();
	
	#ifdef ENABLE_NLS
		bindtextdomain (GETTEXT_PACKAGE, PACKAGE_LOCALE_DIR);
		textdomain (PACKAGE);
	#endif	
	
	if (geteuid()!=0) {
		fprintf(stderr, "You must be root to run tests\n");
		exit(1);
	}
	
	gtk_init (&argc, &argv);	
	g_setenv("PYTHONPATH", "./python", TRUE);
		
	guyummain = g_object_new(GUYUM_TYPE_MAIN, 
							"logfilename", "newlog.log",
							"threshold", 5,
							NULL);
	//CuSuiteAddSuite(sr, make_installtest_suite());	
#if 1
	CuSuiteAddSuite(sr, make_repotest_suite());	
	CuSuiteAddSuite(sr, make_packagetest_suite());	
	CuSuiteAddSuite(sr, make_searchtest_suite());
	CuSuiteAddSuite(sr, make_installtest_suite());
	CuSuiteAddSuite(sr, make_rpmdbtest_suite());
#endif	
	
	CuSuiteRun(sr);
	if (guyummain!=NULL) {
		guyum_main_destroy(guyummain);
	}
		
	CuSuiteSummary(sr, output);	
	CuSuiteDetails(sr, output);
		
	printf("%s\n", output->buffer);
	free(output->buffer);
	free(output);
		
	return 0;
}
