/***************************************************************************
 *            query_tree.c
 *
 *  Wed Jun 28 23:15:59 2006
 *  Copyright  2006  User
 *  Email
 ****************************************************************************/

#include <include/ui/ui_query_tree.h>

extern GuyumMain* guyummain;
extern GladeXML* xml;
extern GtkWidget* window1;
extern GtkWidget* logdialog;
extern GdkCursor* cursor;
extern GtkWidget* depsdialog;

/**
*
*/
void
query_selection_changed (GtkTreeSelection *selection, gpointer user_data)
{
  	GtkTreeModel     *model;
    GtkTreeIter      iter;
	gchar* pkgid = NULL;
	gchar* state = NULL;
	GuyumQueryComponent* query = (GuyumQueryComponent*)user_data;	
	
	/* Get current package list */
	GuyumPackageComposite* packages = NULL;
	
	GOBJECT_GET_POINTER_PROPERTY(query, "packages", packages);	
		
	/* Get actual selected row */
	if (gtk_tree_selection_get_selected(selection, &model, &iter)) {
		GtkButton* install_button;

		gtk_tree_model_get (model, &iter, COL_PACKAGE_PKGID, &pkgid, -1);
		gtk_tree_model_get (model, &iter, COL_PACKAGE_STATE_STRING, &state, -1);

		install_button = GTK_BUTTON(glade_xml_get_widget(xml, "guyum_button_install"));

		if (g_strcasecmp(state, "d")==0 || g_strcasecmp(state, "o")==0) {			
			gtk_widget_set_sensitive(GTK_WIDGET(install_button), FALSE);
		} else {			
			gtk_widget_set_sensitive(GTK_WIDGET(install_button), TRUE);
		}
		if (packages!=NULL) {			
			set_package_information(pkgid, packages);
		}
	}
	/* Free variables */
	g_free(pkgid);	
	g_free(state);
}


/**
*
*/
GtkTreeView*
create_query_treeview()
{
	GtkTreeViewColumn 	*col;
	GtkCellRenderer 	*renderer;
	GtkTreeStore *treestore;
	GtkTreeView* treeview;
	
	treestore = gtk_tree_store_new(NUM_PACKAGE_COLS, 
									GDK_TYPE_PIXBUF, 
									G_TYPE_STRING, 
									G_TYPE_STRING, 
									G_TYPE_STRING, 
									G_TYPE_STRING, 
									G_TYPE_STRING, 
									G_TYPE_STRING, 
									G_TYPE_STRING,
									G_TYPE_STRING);
	
	treeview = GTK_TREE_VIEW(gtk_tree_view_new_with_model(GTK_TREE_MODEL(treestore)));
	
	/* Set rules hint */
	gtk_tree_view_set_rules_hint(GTK_TREE_VIEW(treeview), TRUE);
		
	/* Column state */
	col = gtk_tree_view_column_new();
	gtk_tree_view_column_set_title(col, "");
	gtk_tree_view_append_column(GTK_TREE_VIEW(treeview), col);
	renderer = gtk_cell_renderer_pixbuf_new();
	gtk_tree_view_column_pack_start(col, renderer, TRUE);
	gtk_tree_view_column_add_attribute(col, renderer, "pixbuf", COL_PACKAGE_STATE);	
	
	/* Column name */
	col = gtk_tree_view_column_new();
	gtk_tree_view_column_set_title(col, "Name");
	gtk_tree_view_append_column(GTK_TREE_VIEW(treeview), col);
	renderer = gtk_cell_renderer_text_new();
	gtk_tree_view_column_pack_start(col, renderer, TRUE);
	gtk_tree_view_column_add_attribute(col, renderer, "text", COL_PACKAGE_NAME);		

	/* Column local version */
	col = gtk_tree_view_column_new();
	gtk_tree_view_column_set_title(col, "Local");
	gtk_tree_view_append_column(GTK_TREE_VIEW(treeview), col);
	renderer = gtk_cell_renderer_text_new();
	gtk_tree_view_column_pack_start(col, renderer, TRUE);
	gtk_tree_view_column_add_attribute(col, renderer, "text", COL_PACKAGE_LOCALVERSION);	


	/* Column remote version */
	col = gtk_tree_view_column_new();
	gtk_tree_view_column_set_title(col, "Remote");
	gtk_tree_view_append_column(GTK_TREE_VIEW(treeview), col);
	renderer = gtk_cell_renderer_text_new();
	gtk_tree_view_column_pack_start(col, renderer, TRUE);
	gtk_tree_view_column_add_attribute(col, renderer, "text", COL_PACKAGE_REMOTEVERSION);	


	/* Column size */
	col = gtk_tree_view_column_new();
	gtk_tree_view_column_set_title(col, "Download size");
	gtk_tree_view_append_column(GTK_TREE_VIEW(treeview), col);
	renderer = gtk_cell_renderer_text_new();
	gtk_tree_view_column_pack_start(col, renderer, TRUE);
	gtk_tree_view_column_add_attribute(col, renderer, "text", COL_PACKAGE_SIZE);
	
	/* Column repoid */
	col = gtk_tree_view_column_new();
	gtk_tree_view_column_set_title(col, "Repository");
	gtk_tree_view_append_column(GTK_TREE_VIEW(treeview), col);
	renderer = gtk_cell_renderer_text_new();
	gtk_tree_view_column_pack_start(col, renderer, TRUE);
	gtk_tree_view_column_add_attribute(col, renderer, "text", COL_PACKAGE_REPOID);	
	
	/* Column pkgid: hidden */
	col = gtk_tree_view_column_new();
	gtk_tree_view_append_column(GTK_TREE_VIEW(treeview), col);                         
	renderer = gtk_cell_renderer_text_new();
	gtk_tree_view_column_pack_start(col, renderer, TRUE);
	gtk_tree_view_column_add_attribute(col, renderer, "text", COL_PACKAGE_PKGID);	
	gtk_tree_view_column_set_visible(col, FALSE);	

	/* Column description: hidden */
	col = gtk_tree_view_column_new();
	gtk_tree_view_append_column(GTK_TREE_VIEW(treeview), col);                         
	renderer = gtk_cell_renderer_text_new();
	gtk_tree_view_column_pack_start(col, renderer, TRUE);
	gtk_tree_view_column_add_attribute(col, renderer, "text", COL_PACKAGE_DESCRIPTION);	
	gtk_tree_view_column_set_visible(col, FALSE);	

	/* Column description: state */
	col = gtk_tree_view_column_new();
	gtk_tree_view_append_column(GTK_TREE_VIEW(treeview), col);                         
	renderer = gtk_cell_renderer_text_new();
	gtk_tree_view_column_pack_start(col, renderer, TRUE);
	gtk_tree_view_column_add_attribute(col, renderer, "text", COL_PACKAGE_STATE_STRING);	
	gtk_tree_view_column_set_visible(col, FALSE);	
		
									
	return GTK_TREE_VIEW(treeview);
	
}



/**
*
*/
void
packages_create_and_fill_model(GuyumPackageComposite* packages, GtkTreeView* treeview)
{

	GtkTreeIter toplevel;
	gint i = 0;
	GtkTreeModel *sortmodel;
	GtkTreeStore *treestore = GTK_TREE_STORE(gtk_tree_view_get_model(treeview));	

	for (i=0; i<guyum_package_composite_get_component_count(packages); i++) {		
		gchar* namevalue;
		gchar* localversionvalue;
		gchar* localversion = NULL;
		gchar* localrelease;
		gchar* remoteversionvalue ;
		gchar* remoteversion = NULL;
		gchar* remoterelease ;
		gchar* pkgidvalue;
		gchar* descvalue ;
		gchar* sizevalue;
		gchar* statevalue = NULL;
		gchar* repoidvalue;
		
		GdkPixbuf* pixbuf;
		gchar *statestring = NULL;
		GError* error = NULL;

		GuyumPackageComponent* package = guyum_package_composite_get_nth_component(packages, i);
				
		GOBJECT_GET_STRING_PROPERTY(package, "state", &statestring);
		switch (statestring[0]) {
			case 'o':
				pixbuf = gdk_pixbuf_new_from_file(PACKAGE_SOURCE_DIR"/src/images/ok.png", &error);
				break;
			case 'i':
				pixbuf = gdk_pixbuf_new_from_file(PACKAGE_SOURCE_DIR"/src/images/install.png", &error);
				break;
			case 'u':
				pixbuf = gdk_pixbuf_new_from_file(PACKAGE_SOURCE_DIR"/src/images/update.png", &error);
				break;
			case 'd':
				pixbuf = gdk_pixbuf_new_from_file(PACKAGE_SOURCE_DIR"/src/images/downgrade.png", &error);
				break;
			default:
				pixbuf = gdk_pixbuf_new_from_file(PACKAGE_SOURCE_DIR"/src/images/error.png", &error);
				break;
		}
		
		GOBJECT_GET_STRING_PROPERTY(package, "name", &namevalue);
		GOBJECT_GET_STRING_PROPERTY(package, "localversion", &localversionvalue);
		GOBJECT_GET_STRING_PROPERTY(package, "localrelease", &localrelease);
		GOBJECT_GET_STRING_PROPERTY(package, "remoteversion", &remoteversionvalue);
		GOBJECT_GET_STRING_PROPERTY(package, "remoterelease", &remoterelease);
		GOBJECT_GET_STRING_PROPERTY(package, "pkgsize", &sizevalue);
		GOBJECT_GET_STRING_PROPERTY(package, "repoid", &repoidvalue);
		GOBJECT_GET_STRING_PROPERTY(package, "packageid", &pkgidvalue);
		GOBJECT_GET_STRING_PROPERTY(package, "description", &descvalue);
		
		/* append new line to treeview */
        gtk_tree_store_append(treestore, &toplevel, NULL);
		if (localversionvalue!=NULL && g_strcasecmp(localversionvalue, "")!=0) {
			localversion = g_strconcat(localversionvalue, "-", localrelease, NULL);
		} 
		if (remoteversionvalue!=NULL && g_strcasecmp(remoteversionvalue, "")!=0) {
			remoteversion = g_strconcat(remoteversionvalue, "-", remoterelease, NULL);
		}

		gtk_tree_store_set(treestore, &toplevel, 
							COL_PACKAGE_STATE, pixbuf,
							COL_PACKAGE_NAME, namevalue,
							COL_PACKAGE_LOCALVERSION, localversion,
							COL_PACKAGE_REMOTEVERSION, remoteversion,
							COL_PACKAGE_SIZE, sizevalue,
							COL_PACKAGE_REPOID, repoidvalue,
							COL_PACKAGE_PKGID, pkgidvalue,
							COL_PACKAGE_DESCRIPTION, descvalue,
							COL_PACKAGE_STATE_STRING, statestring,
							-1);

		g_free(namevalue);
		g_free(localversionvalue);
		g_free(localrelease);
		if (localversion!=NULL) {
			g_free(localversion);
		}
		if (remoteversion!=NULL) {
			g_free(remoteversionvalue);
		}
		g_free(remoterelease);
		g_free(remoteversion);
		g_free(pkgidvalue);
		g_free(descvalue);
		g_free(sizevalue);
		g_free(statevalue);
		g_free(repoidvalue);
		g_free(statestring);
		
	}
	sortmodel = gtk_tree_model_sort_new_with_model(GTK_TREE_MODEL(treestore));
	
	gtk_tree_view_set_model(GTK_TREE_VIEW((treeview)), GTK_TREE_MODEL(sortmodel));
	
	if (guyum_package_composite_get_component_count(packages)>0) {
		if (gtk_tree_model_get_iter_first(GTK_TREE_MODEL(treestore), &toplevel)) {
			gtk_tree_sortable_set_sort_column_id(GTK_TREE_SORTABLE(sortmodel), COL_PACKAGE_NAME, GTK_SORT_ASCENDING);
		}
	}
	g_object_unref(treestore);
}
