/***************************************************************************
 *            repodialog_tree.c
 *
 *  Fri Jun 23 11:57:49 2006
 *  Copyright  2006  User
 *  Email
 ****************************************************************************/

#include <include/ui/ui_repodialog_tree.h>

extern GuyumMain* guyummain;
extern GladeXML* xml;
extern GtkWidget* window1;
extern GtkWidget* logdialog;
extern GdkCursor* cursor;
/**
*
*/
void
repoprops_create_and_fill_model(gchar* repoid, GtkTreeView* treeview)
{
	GtkTreeStore *treestore;
	GtkTreeIter toplevel;
	gint i = 0;
	gboolean cont = TRUE;

	const gchar* properties[] = {	"name", "bandwidth", "enablegroups", 
									"gpgcheck", "includepkgs", "keepalive", "proxy",
									"proxy_password", "proxy_username", "exclude",
									"retries", "throttle", "timeout", "mirrorlist",
									"cachedir", "gpgkey", "pkgdir", "hdrdir",
									NULL};

	treestore = gtk_tree_store_new(NUM_REPOPROPS_COLS, 
									G_TYPE_STRING, 
									G_TYPE_STRING);
	
	while(properties[i]!=NULL && cont) {

		gchar* property = guyum_main_get_repo_property(guyummain, repoid, properties[i]);
		
		if (property!=NULL) {

			/* repository treestore */	
			gtk_tree_store_append(treestore, &toplevel, NULL);
			gtk_tree_store_set(treestore, &toplevel, 
								COL_REPOPROPS_KEY, g_strdup(properties[i]),
								COL_REPOPROPS_VALUE, g_strdup(property),
								-1);		
			
		} else {
			if (i==0) {
				show_error_dialog(_("Cannot retrieve repository properties!"));
				cont = FALSE;
			}
		}		
		i++;
	}
	gtk_tree_view_set_model(GTK_TREE_VIEW(treeview), GTK_TREE_MODEL(treestore));

}

/**
*
*/
void
create_repoprops_treemodel(GtkTreeView** treeview, const gchar* repoid)
{
	GtkTreeViewColumn 	*col;
	GtkCellRenderer 	*renderer;

	
	if (gtk_tree_view_get_model((*treeview))==NULL) {
		
		/* Set rules hint */
		gtk_tree_view_set_rules_hint(GTK_TREE_VIEW((*treeview)), TRUE);
		
		/* Column repoid */
		col = gtk_tree_view_column_new();
		gtk_tree_view_column_set_title(col, "Key");
		gtk_tree_view_append_column(GTK_TREE_VIEW((*treeview)), col);
		renderer = gtk_cell_renderer_text_new();
		gtk_tree_view_column_pack_start(col, renderer, TRUE);
		gtk_tree_view_column_add_attribute(col, renderer, "text", COL_REPOPROPS_KEY);
	
		/* Column value */
		col = gtk_tree_view_column_new();
		gtk_tree_view_column_set_title(col, "Value");
		gtk_tree_view_append_column(GTK_TREE_VIEW((*treeview)), col);
		renderer = gtk_cell_renderer_text_new();
		gtk_tree_view_column_pack_start(col, renderer, TRUE);
		gtk_tree_view_column_add_attribute(col, renderer, "text", COL_REPOPROPS_VALUE);		
	}

	repoprops_create_and_fill_model((gchar*)repoid, (*treeview));
	
}
